// GifRunnerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GifRunner.h"
#include "GifRunnerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGifRunnerDlg dialog

CGifRunnerDlg::CGifRunnerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGifRunnerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGifRunnerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_prev = -1;
	m_bFullScreen = FALSE;

}


void CGifRunnerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGifRunnerDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGifRunnerDlg, CDialog)
	//{{AFX_MSG_MAP(CGifRunnerDlg)
	ON_BN_CLICKED(IDC_BUTTON_RUN, OnRun)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGifRunnerDlg message handlers

BOOL CGifRunnerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetIcon( m_hIcon, TRUE );
	SetIcon( m_hIcon, FALSE );
	CenterWindow( GetDesktopWindow() );

	((CComboBox*)GetDlgItem( IDC_ANILIST ))->SetCurSel( 0 );
	return m_player.Create( this );
}


void CGifRunnerDlg::OnRun()
{
	CString string;
	GetDlgItemText( IDC_BUTTON_RUN, string );

	const BOOL bRun = !string.CompareNoCase( L"Run" );
	if( bRun == !m_player.IsLive() )
	{
		if( !bRun )
		{
			if( m_player.Stop() )
			{
				SetDlgItemText( IDC_BUTTON_RUN, L"Run" );
				GetDlgItem( IDC_ANILIST )->EnableWindow( TRUE );
			}
		} else {
			const sel = ((CComboBox*)GetDlgItem( IDC_ANILIST ))->GetCurSel();
			if( sel > -1 )
			{
				if( m_prev != sel )
				{
					m_prev = sel;
					CString fullpath;
					TCHAR szCurPath[ 256 ];
					GetModuleFileName( AfxGetApp()->m_hInstance, szCurPath, 256 );
					*_tcsrchr( szCurPath, '\\' ) = 0;
					fullpath.Format( L"%s\\animation%d.gif", szCurPath, sel + 1 );
					if( !m_player.Load( fullpath ) ) return;
				}

				if( m_player.Play() )
				{
					SetDlgItemText( IDC_BUTTON_RUN, L"Stop" );
					GetDlgItem( IDC_ANILIST )->EnableWindow( FALSE );
				}
			}
		}
	}
}